package com.reactnativenavigation.layouts;

import android.content.Context;
import android.support.annotation.NonNull;
import android.widget.RelativeLayout;

import com.reactnativenavigation.params.ScreenParams;
import com.reactnativenavigation.views.ContentView;

import static android.view.ViewGroup.LayoutParams.MATCH_PARENT;

public class SingleScreen extends Screen {

    private ContentView contentView;

    public SingleScreen(Context context, ScreenParams screenParams) {
        super(context, screenParams);
    }

    @Override
    protected void createContent() {
        contentView = new ContentView(getContext(), screenParams, this);
        addView(contentView, addBelowTopBar());
        contentView.init();
    }

    @NonNull
    private LayoutParams addBelowTopBar() {
        LayoutParams params = new LayoutParams(MATCH_PARENT, MATCH_PARENT);
        if (!screenParams.styleParams.drawUnderTopBar) {
            params.addRule(RelativeLayout.BELOW, topBar.getId());
        }
        return params;
    }

    @Override
    public void ensureUnmountOnDetachedFromWindow() {
        contentView.ensureUnmountOnDetachedFromWindow();
    }

    @Override
    public void preventUnmountOnDetachedFromWindow() {
        contentView.preventUnmountOnDetachedFromWindow();
    }
}
